--- netinet6/udp6_usrreq.c	2006/02/04 05:50:26
+++ netinet6/udp6_usrreq.c	2006/02/19 19:33:03
@@ -117,7 +117,7 @@
  */
 
 extern	struct protosw inetsw[];
-static	int udp6_detach __P((struct socket *so));
+static	void udp6_detach __P((struct socket *so));
 
 int
 udp6_input(mp, offp, proto)
@@ -497,25 +497,19 @@
 	    0, 0,
 	    udp6_getcred, "S,xucred", "Get the xucred of a UDP6 connection");
 
-static int
+static void
 udp6_abort(struct socket *so)
 {
 	struct inpcb *inp;
-	int s;
 
+	inp = sotoinpcb(so);
+	KASSERT(inp != NULL, ("udp6_abort: inp == NULL"));
 	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;	/* ??? possible? panic instead? */
-	}
+	INP_LOCK(inp);
 	soisdisconnected(so);
-	s = splnet();
-	INP_LOCK(inp);
 	in6_pcbdetach(inp);
+	in6_pcbfree(inp);
 	INP_INFO_WUNLOCK(&udbinfo);
-	splx(s);
-	return 0;
 }
 
 static int
@@ -524,21 +518,15 @@
 	struct inpcb *inp;
 	int s, error;
 
-	INP_INFO_WLOCK(&udbinfo);
 	inp = sotoinpcb(so);
-	if (inp != 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
-
+	KASSERT(inp == NULL, ("udp6_attach: inp == NULL"));
 	if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
 		error = soreserve(so, udp_sendspace, udp_recvspace);
-		if (error) {
-			INP_INFO_WUNLOCK(&udbinfo);
+		if (error)
 			return error;
-		}
 	}
 	s = splnet();
+	INP_INFO_WLOCK(&udbinfo);
 	error = in_pcballoc(so, &udbinfo, "udp6inp");
 	splx(s);
 	if (error) {
@@ -570,12 +558,9 @@
 	struct inpcb *inp;
 	int s, error;
 
+	inp = sotoinpcb(so);
+	KASSERT(inp != NULL, ("udp6_bind: inp == NULL"));
 	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
 	INP_LOCK(inp);
 
 	inp->inp_vflag &= ~INP_IPV4;
@@ -615,14 +600,10 @@
 	struct inpcb *inp;
 	int s, error;
 
+	inp = sotoinpcb(so);
+	KASSERT(inp != NULL, ("udp6_connect: inp == NULL"));
 	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
 	INP_LOCK(inp);
-
 	if ((inp->inp_flags & IN6P_IPV6_V6ONLY) == 0) {
 		struct sockaddr_in6 *sin6_p;
 
@@ -666,24 +647,18 @@
 	return error;
 }
 
-static int
+static void
 udp6_detach(struct socket *so)
 {
 	struct inpcb *inp;
-	int s;
 
+	inp = sotoinpcb(so);
+	KASSERT(inp != NULL, ("udp6_detach: inp == NULL"));
 	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
 	INP_LOCK(inp);
-	s = splnet();
 	in6_pcbdetach(inp);
-	splx(s);
+	in6_pcbfree(inp);
 	INP_INFO_WUNLOCK(&udbinfo);
-	return 0;
 }
 
 static int
@@ -692,12 +667,9 @@
 	struct inpcb *inp;
 	int error, s;
 
+	inp = sotoinpcb(so);
+	KASSERT(inp != NULL, ("udp6_disconnect: inp == NULL"));
 	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
 	INP_LOCK(inp);
 
 #ifdef INET
@@ -734,13 +706,9 @@
 	struct inpcb *inp;
 	int error = 0;
 
+	inp = sotoinpcb(so);
+	KASSERT(inp != NULL, ("udp6_send: inp == NULL"));
 	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		m_freem(m);
-		return EINVAL;
-	}
 	INP_LOCK(inp);
 
 	if (addr) {
--- netipsec/keysock.c	2006/01/21 10:48:01
+++ netipsec/keysock.c	2006/02/15 20:29:56
@@ -369,14 +369,11 @@
  * key_abort()
  * derived from net/rtsock.c:rts_abort()
  */
-static int
+static void
 key_abort(struct socket *so)
 {
-	int s, error;
-	s = splnet();
-	error = raw_usrreqs.pru_abort(so);
-	splx(s);
-	return error;
+
+	raw_usrreqs.pru_abort(so);
 }
 
 /*
@@ -459,24 +456,20 @@
  * key_detach()
  * derived from net/rtsock.c:rts_detach()
  */
-static int
+static void
 key_detach(struct socket *so)
 {
 	struct keycb *kp = (struct keycb *)sotorawcb(so);
 	int s, error;
 
-	s = splnet();
-	if (kp != 0) {
-		if (kp->kp_raw.rcb_proto.sp_protocol
-		    == PF_KEY) /* XXX: AF_KEY */
-			key_cb.key_count--;
-		key_cb.any_count--;
+	KASSERT(kp != NULL, ("key_detach: kp == NULL"));
+	if (kp->kp_raw.rcb_proto.sp_protocol
+	    == PF_KEY) /* XXX: AF_KEY */
+		key_cb.key_count--;
+	key_cb.any_count--;
 
-		key_freereg(so);
-	}
-	error = raw_usrreqs.pru_detach(so);
-	splx(s);
-	return error;
+	key_freereg(so);
+	raw_usrreqs.pru_detach(so);
 }
 
 /*
--- netipx/ipx_pcb.c	2005/01/09 05:10:49
+++ netipx/ipx_pcb.c	2006/02/12 19:33:28
@@ -63,6 +63,7 @@
 {
 	register struct ipxpcb *ipxp;
 
+	KASSERT(so->so_pcb == NULL, ("ipx_pcballoc: so_pcb != NULL"));
 	IPX_LIST_LOCK_ASSERT();
 
 	MALLOC(ipxp, struct ipxpcb *, sizeof *ipxp, M_PCB, M_NOWAIT | M_ZERO);
@@ -285,10 +286,7 @@
 	IPX_LIST_LOCK_ASSERT();
 	IPX_LOCK_ASSERT(ipxp);
 
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
 	so->so_pcb = NULL;
-	sotryfree(so);
 	if (ipxp->ipxp_route.ro_rt != NULL)
 		RTFREE(ipxp->ipxp_route.ro_rt);
 	LIST_REMOVE(ipxp, ipxp_list);
--- netipx/ipx_usrreq.c	2005/01/09 05:20:42
+++ netipx/ipx_usrreq.c	2006/02/15 20:30:27
@@ -74,12 +74,12 @@
 SYSCTL_INT(_net_ipx_ipx, OID_AUTO, ipxrecvspace, CTLFLAG_RW,
             &ipxrecvspace, 0, "");
 
-static	int ipx_usr_abort(struct socket *so);
+static	void ipx_usr_abort(struct socket *so);
 static	int ipx_attach(struct socket *so, int proto, struct thread *td);
 static	int ipx_bind(struct socket *so, struct sockaddr *nam, struct thread *td);
 static	int ipx_connect(struct socket *so, struct sockaddr *nam,
 			struct thread *td);
-static	int ipx_detach(struct socket *so);
+static	void ipx_detach(struct socket *so);
 static	int ipx_disconnect(struct socket *so);
 static	int ipx_send(struct socket *so, int flags, struct mbuf *m,
 		     struct sockaddr *addr, struct mbuf *control,
@@ -428,7 +428,7 @@
 	return (error);
 }
 
-static int
+static void
 ipx_usr_abort(so)
 	struct socket *so;
 {
@@ -439,10 +439,6 @@
 	ipx_pcbdetach(ipxp);
 	IPX_LIST_UNLOCK();
 	soisdisconnected(so);
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
-	sotryfree(so);
-	return (0);
 }
 
 static int
@@ -454,13 +450,13 @@
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 	int error;
 
-	if (ipxp != NULL)
-		return (EINVAL);
+	error = soreserve(so, ipxsendspace, ipxrecvspace);
+	if (error != 0)
+		return (error);
+	KASSERT(ipxp == NULL, ("ipx_attach: ipxp != NULL"));
 	IPX_LIST_LOCK();
 	error = ipx_pcballoc(so, &ipxpcb_list, td);
 	IPX_LIST_UNLOCK();
-	if (error == 0)
-		error = soreserve(so, ipxsendspace, ipxrecvspace);
 	return (error);
 }
 
@@ -473,6 +469,7 @@
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 	int error;
 
+	KASSERT(ipxp != NULL, ("ipx_bind: ipxp == NULL"));
 	IPX_LIST_LOCK();
 	IPX_LOCK(ipxp);
 	error = ipx_pcbbind(ipxp, nam, td);
@@ -490,6 +487,7 @@
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 	int error;
 
+	KASSERT(ipxp != NULL, ("ipx_connect: ipxp == NULL"));
 	IPX_LIST_LOCK();
 	IPX_LOCK(ipxp);
 	if (!ipx_nullhost(ipxp->ipxp_faddr)) {
@@ -505,19 +503,17 @@
 	return (error);
 }
 
-static int
+static void
 ipx_detach(so)
 	struct socket *so;
 {
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 
-	if (ipxp == NULL)
-		return (ENOTCONN);
+	KASSERT(ipxp != NULL, ("ipx_detach: ipxp == NULL"));
 	IPX_LIST_LOCK();
 	IPX_LOCK(ipxp);
 	ipx_pcbdetach(ipxp);
 	IPX_LIST_UNLOCK();
-	return (0);
 }
 
 static int
@@ -527,6 +523,7 @@
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 	int error;
 
+	KASSERT(ipxp != NULL, ("ipx_disconnect: ipxp == NULL"));
 	IPX_LIST_LOCK();
 	IPX_LOCK(ipxp);
 	error = 0;
@@ -549,6 +546,7 @@
 {
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 
+	KASSERT(ipxp != NULL, ("ipx_peeraddr: ipxp == NULL"));
 	ipx_setpeeraddr(ipxp, nam);
 	return (0);
 }
@@ -566,6 +564,7 @@
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 	struct ipx_addr laddr;
 
+	KASSERT(ipxp != NULL, ("ipxp_send: ipxp == NULL"));
 	/*
 	 * Attempt to only acquire the necessary locks: if the socket is
 	 * already connected, we don't need to hold the IPX list lock to be
@@ -619,6 +618,8 @@
 ipx_shutdown(so)
 	struct socket *so;
 {
+
+	KASSERT(so->so_pcb != NULL, ("ipx_shutdown: so_pcb == NULL"));
 	socantsendmore(so);
 	return (0);
 }
@@ -630,6 +631,7 @@
 {
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 
+	KASSERT(ipxp != NULL, ("ipx_sockaddr: ipxp == NULL"));
 	ipx_setsockaddr(ipxp, nam);
 	return (0);
 }
@@ -643,6 +645,7 @@
 	int error = 0;
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 
+	KASSERT(ipxp == NULL, ("ripx_attach: ipxp != NULL"));
 	if (td != NULL && (error = suser(td)) != 0)
 		return (error);
 	/*
--- netipx/spx_usrreq.c	2006/01/14 00:11:17
+++ netipx/spx_usrreq.c	2006/02/15 20:30:27
@@ -91,13 +91,13 @@
 static	struct spxpcb *spx_timers(struct spxpcb *cb, int timer);
 static	void spx_usrclosed(struct spxpcb *cb);
 
-static	int spx_usr_abort(struct socket *so);
+static	void spx_usr_abort(struct socket *so);
 static	int spx_accept(struct socket *so, struct sockaddr **nam);
 static	int spx_attach(struct socket *so, int proto, struct thread *td);
 static	int spx_bind(struct socket *so, struct sockaddr *nam, struct thread *td);
 static	int spx_connect(struct socket *so, struct sockaddr *nam,
 			struct thread *td);
-static	int spx_detach(struct socket *so);
+static	void spx_detach(struct socket *so);
 static	int spx_usr_disconnect(struct socket *so);
 static	int spx_listen(struct socket *so, int backlog, struct thread *td);
 static	int spx_rcvd(struct socket *so, int flags);
@@ -1169,6 +1169,8 @@
 	u_short usoptval;
 	int optval;
 
+	KASSERT(ipxp != NULL, ("spx_ctloutput: ipxp == NULL"));
+
 	error = 0;
 
 	if (sopt->sopt_level != IPXPROTO_SPX) {
@@ -1176,10 +1178,7 @@
 		   stacking of protocols */
 		return (ipx_ctloutput(so, sopt));
 	}
-	if (ipxp == NULL)
-		return (EINVAL);
-	else
-		cb = ipxtospxpcb(ipxp);
+	cb = ipxtospxpcb(ipxp);
 
 	switch (sopt->sopt_dir) {
 	case SOPT_GET:
@@ -1295,7 +1294,7 @@
 	return (error);
 }
 
-static int
+static void
 spx_usr_abort(so)
 	struct socket *so;
 {
@@ -1303,13 +1302,14 @@
 	struct spxpcb *cb;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_usr_abort: ipxp == NULL"));
+
 	cb = ipxtospxpcb(ipxp);
 
 	IPX_LIST_LOCK();
 	IPX_LOCK(ipxp);
 	spx_drop(cb, ECONNABORTED);
 	IPX_LIST_UNLOCK();
-	return (0);
 }
 
 /*
@@ -1326,6 +1326,7 @@
 	struct sockaddr_ipx *sipx, ssipx;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_accept: ipxp == NULL"));
 	sipx = &ssipx;
 	bzero(sipx, sizeof *sipx);
 	sipx->sipx_len = sizeof *sipx;
@@ -1350,7 +1351,7 @@
 	int error;
 
 	ipxp = sotoipxpcb(so);
-	cb = ipxtospxpcb(ipxp);
+	KASSERT(ipxp == NULL, ("spx_attach: ipxp != NULL"));
 
 	IPX_LIST_LOCK();
 	error = ipx_pcballoc(so, &ipxpcb_list, td);
@@ -1410,6 +1411,7 @@
 	int error;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_bind: ipxp == NULL"));
 
 	IPX_LIST_LOCK();
 	IPX_LOCK(ipxp);
@@ -1436,6 +1438,7 @@
 	int error;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_connect: ipxp == NULL"));
 	cb = ipxtospxpcb(ipxp);
 
 	IPX_LIST_LOCK();
@@ -1471,7 +1474,7 @@
 	return (error);
 }
 
-static int
+static void
 spx_detach(so)
 	struct socket *so;
 {
@@ -1479,6 +1482,7 @@
 	struct spxpcb *cb;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_detach: ipxp == NULL"));
 	cb = ipxtospxpcb(ipxp);
 
 	IPX_LIST_LOCK();
@@ -1488,7 +1492,6 @@
 	else
 		spx_close(cb);
 	IPX_LIST_UNLOCK();
-	return (0);
 }
 
 /*
@@ -1504,6 +1507,7 @@
 	struct spxpcb *cb;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_usr_disconnect: ipxp == NULL"));
 	cb = ipxtospxpcb(ipxp);
 
 	IPX_LIST_LOCK();
@@ -1576,6 +1580,7 @@
 	struct spxpcb *cb;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_rcvoob: ipxp == NULL"));
 	cb = ipxtospxpcb(ipxp);
 
 	SOCKBUF_LOCK(&so->so_rcv);
@@ -1606,6 +1611,7 @@
 
 	error = 0;
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_send: ipxp == NULL"));
 	cb = ipxtospxpcb(ipxp);
 
 	IPX_LOCK(ipxp);
@@ -1645,6 +1651,7 @@
 	struct spxpcb *cb;
 
 	ipxp = sotoipxpcb(so);
+	KASSERT(ipxp != NULL, ("spx_shutdown: ipxp == NULL"));
 	cb = ipxtospxpcb(ipxp);
 
 	socantsendmore(so);
@@ -1664,6 +1671,8 @@
 	int error;
 	struct ipxpcb *ipxp;
 
+	KASSERT(so->so_pcb == NULL, ("spx_sp_attach: so_pcb != NULL"));
+
 	error = spx_attach(so, proto, td);
 	if (error == 0) {
 		ipxp = sotoipxpcb(so);
--- netkey/keysock.c	2006/01/21 10:48:01
+++ netkey/keysock.c	2006/02/15 20:30:53
@@ -278,14 +278,11 @@
  * key_abort()
  * derived from net/rtsock.c:rts_abort()
  */
-static int
+static void
 key_abort(struct socket *so)
 {
-	int s, error;
-	s = splnet();
-	error = raw_usrreqs.pru_abort(so);
-	splx(s);
-	return error;
+
+	raw_usrreqs.pru_abort(so);
 }
 
 /*
@@ -298,8 +295,7 @@
 	struct keycb *kp;
 	int s, error;
 
-	if (sotorawcb(so) != 0)
-		return EISCONN;	/* XXX panic? */
+	KASSERT(sotorawcb(so) == NULL, ("key_attach: so_pcb != NULL"));
 	kp = (struct keycb *)malloc(sizeof *kp, M_PCB, M_WAITOK); /* XXX */
 	if (kp == 0)
 		return ENOBUFS;
@@ -369,24 +365,17 @@
  * key_detach()
  * derived from net/rtsock.c:rts_detach()
  */
-static int
+static void
 key_detach(struct socket *so)
 {
 	struct keycb *kp = (struct keycb *)sotorawcb(so);
-	int s, error;
 
-	s = splnet();
-	if (kp != 0) {
-		if (kp->kp_raw.rcb_proto.sp_protocol
-		    == PF_KEY) /* XXX: AF_KEY */
-			key_cb.key_count--;
-		key_cb.any_count--;
-
-		key_freereg(so);
-	}
-	error = raw_usrreqs.pru_detach(so);
-	splx(s);
-	return error;
+	KASSERT(kp != NULL, ("key_detach: kp == NULL"));
+	if (kp->kp_raw.rcb_proto.sp_protocol == PF_KEY) /* XXX: AF_KEY */
+		key_cb.key_count--;
+	key_cb.any_count--;
+	key_freereg(so);
+	raw_usrreqs.pru_detach(so);
 }
 
 /*
--- netnatm/natm.c	2005/08/09 10:22:44
+++ netnatm/natm.c	2006/02/15 20:31:08
@@ -74,7 +74,7 @@
  * user requests
  */
 static int natm_usr_attach(struct socket *, int, d_thread_t *);
-static int natm_usr_detach(struct socket *);
+static void natm_usr_detach(struct socket *);
 static int natm_usr_connect(struct socket *, struct sockaddr *, d_thread_t *);
 static int natm_usr_disconnect(struct socket *);
 static int natm_usr_shutdown(struct socket *);
@@ -83,7 +83,7 @@
 static int natm_usr_peeraddr(struct socket *, struct sockaddr **);
 static int natm_usr_control(struct socket *, u_long, caddr_t,
     struct ifnet *, d_thread_t *);
-static int natm_usr_abort(struct socket *);
+static void natm_usr_abort(struct socket *);
 static int natm_usr_bind(struct socket *, struct sockaddr *, d_thread_t *);
 static int natm_usr_sockaddr(struct socket *, struct sockaddr **);
 
@@ -94,7 +94,6 @@
     int error = 0;
 
     npcb = (struct natmpcb *)so->so_pcb;
-
     KASSERT(npcb == NULL, ("natm_usr_attach: so_pcb != NULL"));
 
     if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
@@ -112,31 +111,17 @@
     return (error);
 }
 
-static int
+static void
 natm_usr_detach(struct socket *so)
 {
     struct natmpcb *npcb;
-    int error = 0;
 
     NATM_LOCK();
     npcb = (struct natmpcb *)so->so_pcb;
-    if (npcb == NULL) {
-	/* XXXRW: Does this case ever actually happen? */
-	error = EINVAL;
-	goto out;
-    }
-
-    /*
-     * we turn on 'drain' *before* we sofree.
-     */
+    KASSERT(npcb != NULL, ("natm_usr_detach: npcb == NULL"));
     npcb_free(npcb, NPCB_DESTROY);	/* drain */
-    ACCEPT_LOCK();
-    SOCK_LOCK(so);
     so->so_pcb = NULL;
-    sotryfree(so);
- out:
     NATM_UNLOCK();
-    return (error);
 }
 
 static int
@@ -151,11 +136,7 @@
 
     NATM_LOCK();
     npcb = (struct natmpcb *)so->so_pcb;
-    if (npcb == NULL) {
-	/* XXXRW: Does this case ever actually happen? */
-	error = EINVAL;
-	goto out;
-    }
+    KASSERT(npcb != NULL, ("natm_usr_connect: npcb == NULL"));
 
     /*
      * validate nam and npcb
@@ -212,18 +193,14 @@
     if (ifp->if_ioctl == NULL || 
 	ifp->if_ioctl(ifp, SIOCATMOPENVCC, (caddr_t)&op) != 0) {
 	IFF_UNLOCKGIANT(ifp);
-	NATM_LOCK();
-	npcb_free(npcb, NPCB_REMOVE);
         error = EIO;
 	goto out;
     }
     IFF_UNLOCKGIANT(ifp);
 
-    NATM_LOCK();
     soisconnected(so);
 
  out:
-    NATM_UNLOCK();
     return (error);
 }
 
@@ -237,11 +214,7 @@
 
     NATM_LOCK();
     npcb = (struct natmpcb *)so->so_pcb;
-    if (npcb == NULL) {
-	/* XXXRW: Does this case ever actually happen? */
-	error = EINVAL;
-	goto out;
-    }
+    KASSERT(npcb != NULL, ("natm_usr_disconnect: npcb == NULL"));
 
     if ((npcb->npcb_flags & NPCB_CONNECTED) == 0) {
         printf("natm: disconnected check\n");
@@ -263,7 +236,6 @@
     }
     NATM_LOCK();
 
-    npcb_free(npcb, NPCB_REMOVE);
     soisdisconnected(so);
 
  out:
@@ -289,11 +261,7 @@
 
     NATM_LOCK();
     npcb = (struct natmpcb *)so->so_pcb;
-    if (npcb == NULL) {
-	/* XXXRW: Does this case ever actually happen? */
-	error = EINVAL;
-	goto out;
-    }
+    KASSERT(npcb != NULL, ("natm_usr_send: npcb == NULL"));
 
     if (control && control->m_len) {
 	m_freem(control);
@@ -330,11 +298,7 @@
 
     NATM_LOCK();
     npcb = (struct natmpcb *)so->so_pcb;
-    if (npcb == NULL) {
-	/* XXXRW: Does this case ever actually happen? */
-    	NATM_UNLOCK();
-	return (EINVAL);
-    }
+    KASSERT(npcb != NULL, ("natm_usr_peeraddr: npcb == NULL"));
 
     snatm = &ssnatm;
     bzero(snatm, sizeof(*snatm));
@@ -356,13 +320,8 @@
     struct natmpcb *npcb;
     int error;
 
-    /*
-     * XXXRW: Does this case ever actually happen?  And does it even matter
-     * given that npcb is unused?
-     */
     npcb = (struct natmpcb *)so->so_pcb;
-    if (npcb == NULL)
-	return (EINVAL);
+    KASSERT(npcb != NULL, ("natm_usr_control: npcb == NULL"));
 
     if (ifp == NULL || ifp->if_ioctl == NULL)
 	return (EOPNOTSUPP);
@@ -373,10 +332,10 @@
     return (error);
 }
 
-static int
+static void
 natm_usr_abort(struct socket *so)
 {
-    return (natm_usr_shutdown(so));
+    natm_usr_shutdown(so);
 }
 
 static int
--- sys/protosw.h	2005/10/30 19:45:29
+++ sys/protosw.h	2006/02/13 21:54:01
@@ -196,7 +196,7 @@
  */
 struct pr_usrreqs {
 	double	__Break_the_struct_layout_for_now;
-	int	(*pru_abort)(struct socket *so);
+	void	(*pru_abort)(struct socket *so);
 	int	(*pru_accept)(struct socket *so, struct sockaddr **nam);
 	int	(*pru_attach)(struct socket *so, int proto, struct thread *td);
 	int	(*pru_bind)(struct socket *so, struct sockaddr *nam,
@@ -206,7 +206,7 @@
 	int	(*pru_connect2)(struct socket *so1, struct socket *so2);
 	int	(*pru_control)(struct socket *so, u_long cmd, caddr_t data,
 		    struct ifnet *ifp, struct thread *td);
-	int	(*pru_detach)(struct socket *so);
+	void	(*pru_detach)(struct socket *so);
 	int	(*pru_disconnect)(struct socket *so);
 	int	(*pru_listen)(struct socket *so, int backlog,
 		    struct thread *td);
@@ -246,7 +246,7 @@
  * All nonvoid pru_*() functions below return EOPNOTSUPP.
  */
 
-int	pru_abort_notsupp(struct socket *so);
+void	pru_abort_notsupp(struct socket *so);
 int	pru_accept_notsupp(struct socket *so, struct sockaddr **nam);
 int	pru_attach_notsupp(struct socket *so, int proto, struct thread *td);
 int	pru_bind_notsupp(struct socket *so, struct sockaddr *nam,
@@ -256,7 +256,7 @@
 int	pru_connect2_notsupp(struct socket *so1, struct socket *so2);
 int	pru_control_notsupp(struct socket *so, u_long cmd, caddr_t data,
 	    struct ifnet *ifp, struct thread *td);
-int	pru_detach_notsupp(struct socket *so);
+void	pru_detach_notsupp(struct socket *so);
 int	pru_disconnect_notsupp(struct socket *so);
 int	pru_listen_notsupp(struct socket *so, int backlog, struct thread *td);
 int	pru_peeraddr_notsupp(struct socket *so, struct sockaddr **nam);
--- sys/socketvar.h	2006/01/13 11:03:11
+++ sys/socketvar.h	2006/02/19 15:46:04
@@ -208,6 +208,14 @@
 #define	SS_ASYNC		0x0200	/* async i/o notify */
 #define	SS_ISCONFIRMING		0x0400	/* deciding to accept connection req */
 #define	SS_ISDISCONNECTED	0x2000	/* socket disconnected from peer */
+/*
+ * Protocols can mark a socket as SS_PROTOREF to indicate that, following
+ * pru_detach, they still want the socket to persist, and will free it
+ * themselves when they are done.  Protocols should only ever call sofree()
+ * following setting this flag in pru_detach(), and never otherwise, as
+ * sofree() bypasses socket reference counting.
+ */
+#define	SS_PROTOREF		0x4000	/* strong protocol reference present */
 
 /*
  * Socket state bits now stored in the socket buffer state field.
@@ -486,7 +494,7 @@
 void	sbtoxsockbuf(struct sockbuf *sb, struct xsockbuf *xsb);
 int	sbwait(struct sockbuf *sb);
 int	sb_lock(struct sockbuf *sb);
-int	soabort(struct socket *so);
+void	soabort(struct socket *so);
 int	soaccept(struct socket *so, struct sockaddr **nam);
 struct	socket *soalloc(int mflags);
 int	socheckuid(struct socket *so, uid_t uid);
